MsWksDBParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
MsWksDBParser Class Referencefinal

the main class to read a Microsoft Works database file and convert it in a spreadsheet file More...

`#include <MsWksDBParser.hxx>`

Inheritance diagram for MsWksDBParser:

## Public Member Functions
| MsWksDBParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~MsWksDBParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
const MWAWPageSpan & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readDataBase ()
| try to read the database zone More...
bool | sendDatabase ()
| try to send the main database More...
bool | readFieldTypes ()
| reads the list of the fields type v3-v4 More...
bool | readFieldTypesV2 ()
| reads the list of the fields type v2 More...
bool | readRecords (bool onlyCheck)
| reads the database contents: field's names and values More...
bool | readFilters ()
| reads the filters More...
bool | readColSize (std::vector< int > &colSize)
| reads the list of the columns size More...
bool | readDefaultValues ()
| reads the default value More...
bool | readFormula ()
| reads the formula value More...
bool | readSerialFormula ()
| reads the serial value More...
bool | readForms ()
| reads all the form More...
bool | readFormV2 ()
| reads a list of dimension(?) corresponding to the fields type v2 More...
bool | readForm ()
| reads one form More...
bool | readFormTypes (MsWksDBParserInternal::Form &form)
| read a form types More...
bool | readReports ()
| reads the reports More...
bool | readReportHeader ()
| read a report header More...
bool | readReportV2 ()
| reads a report zone in v.2 file More...
bool | readUnknownV2 ()
| reads an unknown zone V2 More...
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
const std::string & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< MsWksDBParserInternal::State > | m_state
| the state More...
std::vector< MWAWEntry > | m_listZones
| the list of different Zones More...
std::shared_ptr< MsWksDocument > | m_document
| the actual zone More...

## Friends
class | MsWksDBParserInternal::SubDocument

## Detailed Description

the main class to read a Microsoft Works database file and convert it in a spreadsheet file

## Constructor & Destructor Documentation

## ◆ MsWksDBParser()

MsWksDBParser::MsWksDBParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MsWksDBParser()

MsWksDBParser::~MsWksDBParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MsWksDBParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MsWksDBParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MsWksDBParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ init()

void MsWksDBParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MsWksDBParser().

## ◆ parse()

void MsWksDBParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWSpreadsheetParser.

## ◆ readColSize()

bool MsWksDBParser::readColSize | ( | std::vector< int > & | colSize | ) |
| protected

reads the list of the columns size

Referenced by readForms(), readFormV2(), and readReportV2().

## ◆ readDataBase()

bool MsWksDBParser::readDataBase | ( |  | ) |
| protected

try to read the database zone

Referenced by createZones().

## ◆ readDefaultValues()

bool MsWksDBParser::readDefaultValues | ( |  | ) |
| protected

reads the default value

Referenced by readDataBase().

## ◆ readFieldTypes()

bool MsWksDBParser::readFieldTypes | ( |  | ) |
| protected

reads the list of the fields type v3-v4

Referenced by readDataBase().

## ◆ readFieldTypesV2()

bool MsWksDBParser::readFieldTypesV2 | ( |  | ) |
| protected

reads the list of the fields type v2

Referenced by readDataBase().

## ◆ readFilters()

bool MsWksDBParser::readFilters | ( |  | ) |
| protected

reads the filters

Referenced by readDataBase().

## ◆ readForm()

bool MsWksDBParser::readForm | ( |  | ) |
| protected

reads one form

Referenced by readForms().

## ◆ readForms()

bool MsWksDBParser::readForms | ( |  | ) |
| protected

reads all the form

Referenced by createZones(), and readReports().

## ◆ readFormTypes()

bool MsWksDBParser::readFormTypes | ( | MsWksDBParserInternal::Form & | form | ) |
| protected

read a form types

[ff,5c,_,-8,_,-9] or [ff,a8,_,-8,_,-9] or [_,5c,_,-8,_,-9]

Referenced by readForm().

## ◆ readFormula()

bool MsWksDBParser::readFormula | ( |  | ) |
| protected

reads the formula value

Referenced by readDataBase().

## ◆ readFormV2()

bool MsWksDBParser::readFormV2 | ( |  | ) |
| protected

reads a list of dimension(?) corresponding to the fields type v2

Referenced by readDataBase().

## ◆ readRecords()

bool MsWksDBParser::readRecords | ( | bool | onlyCheck | ) |
| protected

reads the database contents: field's names and values

Note
  if onlyCheck = true, only check if the zone is ok but do nothing

Referenced by readDataBase().

## ◆ readReportHeader()

bool MsWksDBParser::readReportHeader | ( |  | ) |
| protected

read a report header

Referenced by readReports().

## ◆ readReports()

bool MsWksDBParser::readReports | ( |  | ) |
| protected

reads the reports

Referenced by createZones().

## ◆ readReportV2()

bool MsWksDBParser::readReportV2 | ( |  | ) |
| protected

reads a report zone in v.2 file

Referenced by readDataBase().

## ◆ readSerialFormula()

bool MsWksDBParser::readSerialFormula | ( |  | ) |
| protected

reads the serial value

reads the serial formula

Referenced by readDataBase().

## ◆ readUnknownV2()

bool MsWksDBParser::readUnknownV2 | ( |  | ) |
| protected

reads an unknown zone V2

Note
  this header looks like the form v3-4 header, but is it really the form header ?

Referenced by readDataBase().

## ◆ sendDatabase()

bool MsWksDBParser::sendDatabase | ( |  | ) |
| protected

try to send the main database

Referenced by parse().

## Friends And Related Function Documentation

## ◆ MsWksDBParserInternal::SubDocument

friend class MsWksDBParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_document

std::shared_ptr<MsWksDocument> MsWksDBParser::m_document
| protected

the actual zone

Referenced by checkHeader(), createDocument(), createZones(), MsWksDBParser(), parse(), readColSize(), readDataBase(), readDefaultValues(), readFieldTypes(), readFieldTypesV2(), readFilters(), readForm(), readForms(), readFormTypes(), readFormula(), readFormV2(), readRecords(), readReportHeader(), readReports(), readReportV2(), readSerialFormula(), readUnknownV2(), and sendDatabase().

## ◆ m_listZones

std::vector<MWAWEntry> MsWksDBParser::m_listZones
| protected

the list of different Zones

## ◆ m_state

std::shared_ptr<MsWksDBParserInternal::State> MsWksDBParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), readDataBase(), readDefaultValues(), readFieldTypes(), readFieldTypesV2(), readForm(), readForms(), readFormTypes(), readFormula(), readFormV2(), readRecords(), readReports(), readSerialFormula(), and sendDatabase().

The documentation for this class was generated from the following files:

- MsWksDBParser.hxx
- MsWksDBParser.cxx